\input{../../include/schemes-reference}
\input{../../include/schemes}
\begin{document}
\begin{tikzpicture}[
    submatrix/.style = {draw = black, line width = \submatrixlinewidth},
    submatrixoverlay/.style = {
      draw = white, draw opacity = 0, fill = white, fill opacity = 0.8,
      line width = \submatrixlinewidth
    },
    submatrixlabel/.style = {
      draw = black, fill = white, anchor = center, align = center,
      scale = \labelscale, inner sep = \labelinnersep,
      line width = \labellinewidth
    }
  ]
  % Top green and red lines.
  \draw[
    draw = green, line width = \sidelinewidth
  ] (-1.55 * \drawscale, 1.7 * \drawscale) node{}
  -- (0.45 * \drawscale, 1.7 * \drawscale);
  \draw[
    draw = red, line width = \sidelinewidth
  ] (0.55 * \drawscale, 1.7 * \drawscale) node{}
  -- (1.55 * \drawscale, 1.7 * \drawscale);
  % Left green and red lines.
  \draw[
    draw = green, line width = \sidelinewidth
  ] (-1.7 * \drawscale, 1.55 * \drawscale) node{}
  -- (-1.7 * \drawscale, -0.45 * \drawscale);
  \draw[
    draw = red, line width = \sidelinewidth
  ] (-1.7 * \drawscale, -0.55 * \drawscale) node{}
  -- (-1.7 * \drawscale, -1.55 * \drawscale);
  % Blocks
  \draw[draw = repetition, line width = 2 * \sidelinewidth]
  (-1.55 * \drawscale, 1.55 * \drawscale) rectangle
  ++(2.6 * \drawscale, -2.6 * \drawscale);
  \draw[draw = repetition, line width = 2 * \sidelinewidth]
  (1.85 * \drawscale, -0.55 * \drawscale) rectangle
  ++(0.5 * \drawscale, -0.5 * \drawscale);
  % Sparse/dense matrix.
  \node[
    matrix, draw = black, line width = \matrixlinewidth,
    inner sep = \matrixinnersep
  ] (FB) at (0, 0) {
    \draw[
      submatrix, pattern = compressed, pattern color = green
    ] (0, 0) node[anchor = west]{}
    -- (2 * \drawscale, 0) node[anchor = north]{}
    -- (0, 2 * \drawscale) node[anchor = north west]{}
    -- cycle;
    \node[submatrixlabel] (Avv) at (1 * \drawscale, 1 * \drawscale) {
      $L_{vv}$ \\ [-2mm]
      {\tiny \textit{\textbf{compressed}}} \\ [-2mm]
      {\tiny \textit{\textbf{sparse}}} \\ [-2mm]
      {\tiny \textit{with fill-in}}
    }; & \\ [-3mm]
    \draw[
      submatrix, pattern = compressed,
    ] (0, 0) rectangle ++(2 * \drawscale, 1 * \drawscale);
    \draw[
      submatrixoverlay
    ] (0, 0) rectangle ++(2 * \drawscale, 0.46 * \drawscale);
    \node[submatrixlabel] (Asv) at (1 * \drawscale, 0.5 * \drawscale) {
      $A_{sv}(L_{vv}^T)^{-1}$ \\ [-2mm]
      {\tiny \textit{\textbf{compressed}}} \\ [-2mm]
      {\tiny \textit{\textbf{sparse}}} \\ [-2mm]
      {\tiny \textit{with fill-in}}
    }; &
    \draw[
      submatrix, pattern = compressed, pattern color = red
    ] (0, 0) node[anchor = south west]{}
    -- (1 * \drawscale, 0) node[anchor = south east]{}
    -- (0, 1 * \drawscale) node[anchor = north west]{}
    -- cycle;
    \draw[
      submatrixoverlay
    ] (0, 0) node[anchor = south west]{}
    -- (1 * \drawscale, 0) node[anchor = south east]{}
    -- (0.55 * \drawscale, 0.46 * \drawscale) node[anchor = south east]{}
    -- (0, 0.46 * \drawscale) node[anchor = north west]{}
    -- cycle;
    \node[submatrixlabel] (S) at (0.5 * \drawscale, 0.5 * \drawscale) {
      $S$ \\ [-2mm]
      $\scriptscriptstyle A_{ss} + X$ \\ [-2mm]
      {\tiny \textit{\textbf{compressed}}} \\ [-2mm]
      {\tiny \textit{\textbf{dense}}}
    }; \\
  };
  \draw[
    submatrix, pattern = compressed, pattern color = black
  ] (2 * \drawscale, -1.055 * \drawscale) node[anchor = west]{}
  -- (2.5 * \drawscale, -1.055 * \drawscale) node[anchor = north]{}
  -- (2 * \drawscale, -0.6 * \drawscale) node[anchor = north west]{}
  -- cycle;
  \draw[
    submatrix, pattern = dense, pattern color = black
  ] (1.85 * \drawscale, -1.55 * \drawscale) node[anchor = west]{}
  -- (2.85 * \drawscale, -1.55 * \drawscale) node[anchor = north]{}
  -- (1.85 * \drawscale, -0.55 * \drawscale) node[anchor = north west]{}
  -- cycle;
  \draw[
    submatrixoverlay
  ]  (1.85 * \drawscale, -1.55 * \drawscale) node[anchor = west]{}
  -- (2.85 * \drawscale, -1.55 * \drawscale) node[anchor = north]{}
  -- (2.39 * \drawscale, -1.09 * \drawscale) node[anchor = north]{}
  -- (1.85 * \drawscale, -1.09 * \drawscale) node[anchor = north west]{}
  -- cycle;
  \node[submatrixlabel] (X) at (2.4 * \drawscale, -1.05 * \drawscale) {
    $-X$ \\ [-2mm]
    {\tiny \textit{\textbf{dense}}}
  };
  \draw[-{Stealth[length=5mm]}, line width = \submatrixlinewidth] (X) -- (S);
  \node[anchor = south east] (Xdense) at
  (1.85 * \drawscale, -0.55 * \drawscale) {};
  \node[anchor = base] (Xcompr) at (2 * \drawscale, -0.6 * \drawscale) {};
  \path[
    -{latex[length=5mm]}, line width = \submatrixlinewidth
  ] (Xdense) edge[out = 50, in = 100] node [right, anchor = south west]
       {\LARGE \textbf{~compress}} (Xcompr);
\end{tikzpicture}
\end{document}
